Imports System
Imports System.Linq
Imports EnvDTE

$VBNamespaceBegin$
Public Partial Class $safeitemrootname$
    Private _codeElements As Dictionary(Of String, List(Of CodeInterface))

    Public ReadOnly Property CodeElements As Dictionary(Of String, List(Of CodeInterface))
        Get
            If Me._codeElements Is Nothing Then
                ' the interfaces defined in this file that reference at least one data interface.
                Me._codeElements = MyBase.ProjectItem.GetCodeElements(Of CodeInterface)()
            End If

            Return Me._codeElements
        End Get
    End Property

    Private Sub RenderMethods(interf As CodeInterface)
        Dim q = (From i In Me.CodeElements(interf.FullName) _
                 From codeElement In i.Members.OfType(Of CodeElement)() _
                 Where CodeElement.Kind = vsCMElement.vsCMElementFunction _
                 Select CodeElement
                ).OfType(Of CodeFunction)()
        For Each method In q
            Me.RenderMethod(method)
            MyBase.Output.WriteLine()
        Next method
    End Sub

    Public Function GetMethodCall(ByVal method As CodeFunction) As String
        Dim result As String = method.Prototype(CType(vsCMPrototype.vsCMPrototypeParamNames, Integer))
        result = result.Replace("ByVal ", String.Empty)
        result = result.Replace("ByRef ", String.Empty)
        result = result.Replace(" )", ")")
        Return result
    End Function

End Class
$VBNamespaceEnd$